/* ************************************************************************************
 *	Das Modul beinhaltet Variablendeklarationen sowie Definitionen und
 *  Initialisierungswerte. Dasselbe gilt fr Objekte der Ein- und Ausgabe.
 *	Die Datei ist nicht in der allgemeinen Bibliothek gespeichert, sondern
 *	lokal bei der HTML-Seite des Programms.
 *
 *	The module contains variable declarations as well as definitions and
 *  Initialization values.  The same applies to objects of input and output.
 *	The file is not stored in the general library, but
 *	Locally at the HTML page of the program.
 *
 *
 *
 *	Erstellt:	31.05.2021	Dieter Steffan
 *
 *********************************************************************************** */	

/* ***************** Variablen Deklarationen - Variable declarations ************************ */
				
var JD = 0.0;							// Das Julianische Datum eines Gregorianischen Datums
												// The Julian date of a Gregorian date
var ISDST;								// Zeigt an, ob Daylight Saving Time
												// Indicates whether Daylight Saving Time
var TZ = 0;								// Nimmt die Zeitzone auf
												// Accepts the time zone
var newmoon = 0.0;					// Wert fr den Neumond als Jul. Datum
												// Value for the new moon as Jul.  Date
var fullmoon = 0.0;					// Wert fr den Vollmond als Jul. Datum
												// Value for the full moon as Jul.  Date
var GDayFullMoon = 0.0;			// Der Greenwich Tag des Vollmonds als Dezimalwert 
												// The Greenwich Day of the Full Moon as a Decimal Value
var GDayFullMoonInt = 0;		// Der Greenwich Tag des Vollmonds als Integer
												// The Greenwich Day of the Full Moon as a integer
var GMonthFullMoonInt = 0;		// Der Greenwich Monat des Vollmonds als Integer
												// The Greenwich Month of the Full Moon as a integer
var GYearFullMoonInt = 0;		// Der Greenwich jahr des Vollmonds als Integer
												// The Greenwich Year of the Full Moon as a integer
var UTFullMoon = 0.0;				// Universal Zeit (UT) des Vollmonds
												// Universal time (UT) of the full moon
var LCTFullMoon = 0.0;			// Lokale Zeit (LCT) des Vollmonds
												// Local time (LCT) of the full moon
var LCTDayFullMoon = 0;		// Lokaler Tag (LCT) des Vollmonds
												// Local day (LCT) of the full moon
var LCTmonthFullMoon = 0;		// Lokaler Monat (LCT) des Vollmonds
												// Local month (LCT) of the full moon
var LCTYearFullMoon = 0;		// Lokales Jahr (LCT) des Vollmonds
												// Local year (LCT) of the full moon
var LCTTimeLocalFull = "";		// Lokale Zeit (hh:mm:ss.ms) des Vollmonds
												// Local time (hh:mm:ss.ms) of the full moon
												
var GDayNewMoon = 0.0;		// Der Greenwich Tag des Vollmonds als Dezimalwert 
												// The Greenwich Day of the New Moon as a Decimal Value
var GDayNewMoonInt = 0;		// Der Greenwich Tag des Vollmonds als Integer
												// The Greenwich Day of the New Moon as a integer
var GMonthNewMoonInt = 0;	// Der Greenwich Monat des Vollmonds als Integer
												// The Greenwich Month of the New Moon as a integer
var GYearNewMoonInt = 0;		// Der Greenwich jahr des Vollmonds als Integer
												// The Greenwich Year of the New Moon as a integer
var UTNewMoon = 0.0;				// Universal Zeit (UT) des Vollmonds
												// Universal time (UT) of the New moon
var LCTNewMoon = 0.0;			// Lokale Zeit (LCT) des Vollmonds
												// Local time (LCT) of the New moon
var LCTDayNewMoon = 0;		// Lokaler Tag (LCT) des Vollmonds
												// Local day (LCT) of the New moon
var LCTmonthNewMoon = 0;		// Lokaler Monat (LCT) des Vollmonds
												// Local month (LCT) of the New moon
var LCTYearNewMoon = 0;		// Lokales Jahr (LCT) des Vollmonds
												// Local year (LCT) of the New moon
var LCTTimeLocalNew = "";		// Lokale Zeit (hh:mm:ss.ms) des Vollmonds
												// Local time (hh:mm:ss.ms) of the New moon
var saveMonth = 0;					// Sichert den aktuellen Tag Monat und Jahr zum Vergleich
var saveYear = 0;						// Saves the current day, month and year for comparison
var saveDay = 0;						// ...
var yearIsCalculated = false;	// Schalter fr Jahr berechnet oder nicht
												// Switch for year calculated or not

/* ***************** Verwendete Objekte - Used objects ************************ */

// Datums objekt fr das automatische Fllen
var d = new Date();			
// Objekt des Berechnen Buttons
// Object of the calculation button
var objCalc = document.getElementById("calc");	
// Objekt der Eingabe des zu berechnenden Jahres
// Object of entry of the year to be calculated
var objYear = document.getElementById("year");
// Objekt der Eingabe des zu berechnenden Monats
// Object of the input of the month to be calculated
var objMonth = document.getElementById("month");
// Objekt der Eingabe des zu berechnenden Tages
// Object of the input of the day to be calculated
var objDay = document.getElementById("day");
// Objekte der Ausgabefelder
// Objects of the output fields
//
// Objekt der Ausgabe des Julianisches Datum der Epoche 
// 2010 zum 0.1. 00:00:00:000
// Object of the issue of the Julian Date of the Epoch
// 2010 to 0. 1. 00:00:00:000
var objJD = document.getElementById("jd");
// Objekt der Ausgabe des Schaltjahres
// Object of the output of the leap year
var objLeapYear = document.getElementById("leapyear");
// Objekt der Eingabe/Ausgabe der Daylight Saving Time und Timezone
// DST = 1 = Sommerzeit
// Tz = 1 = MEZ
//
// Object of input/output of the Daylight Saving Time and Timezone
// DST = 1 = summer time
// Tz = 1 = MEZ
var objDST = document.getElementById("dst");
var objTZ = document.getElementById("tz");
// Objekt der Ausgabe Julianischen Datum des Startdatum
// Object of the edition Julian date of the start date
var objJD0 = document.getElementById("jd0");
// Das Startdatum der Berechnungen
// The start date of the calculation
//var objStartDate = document.getElementById("startdate");
// Objekt der Ausgabe des Datums Neumond
var objNewMoon = document.getElementById("newmoon");
// Objekt der Ausgabe des Datums Vollmond
var objFullMoon = document.getElementById("fullmoon");
// Objekt der HTML Seite body
// Object of the HTML page body
var objB = document.getElementById("b");
// Objekt der Textarea und Variable fr den Inhalt
// Object of the textarea and variable for the input of textarea
var objText = document.getElementById("text");
var s = "";
// Objekt der Checkbox fr das Berechnen des ganzen Jahres und Ausgabe in der Textarea
// Object of thecheckbox to calculate newmoon and fullmoon for the whole year and output to
// the textarea below
var objCalcYear = document.getElementById("calcyear");
