var DELAYJD = 1000;							// Wartezeit fr das Julianische Datum bis die Threads wieder ausgefhrt werden
var TIMELAPS = 0;								// Der Zeitsprung, in dessen Abstand die Berechnungen gemacht werden sollen 
var startProgressTimeJD = 0;				// Startzeit fr die Verarbeitungsdauer JD
var stopProgressTimeJD = 0;				// Stopzeit fr die Verarbeitungsdauer JD
var diffProgressTimeJD = 0;					// Die Zeitdifferenz der Verarbeitung des JD
var splitData = [];									// Array mit empfangenen Daten
var dataLineNumber = 0;						// Die Zeilennummerierung fr die an den Hauptthread zu sendenden Daten.
var channel = new BroadcastChannel ("com"); // Neuen Nachrichtenkanal zum Hauptprogramm erstellen.

// Der Eventhandler des Worker fr Messages ber den Broadcast Kanal.
//
channel.onmessage = function (e){
	// Delay beim Senden vom Hauptthread, wenn die Geschwindigkeit
	// im Overlay gendert wird.
	DELAYJD = e.data;
	// An den Hauptthread die verwendete Delay melden, damit
	// sie im Overlay unter Aktiv eingetragen wird.
	//
	channel.postMessage(DELAYJD);
}



onmessage = function (event){
	// Im Array splitData findet man zwei Werte als Key=Value.
	// Sie sind durch "=" getrennt.
	splitData = event.data.split("=");
	// Hier, nach dem Key, die einzelnen Ergebnisse den Ausgabebereichen
	// zuweisen.
	if (splitData[0] == "timelaps"){
		TIMELAPS = splitData[1];
	}
	if (splitData[0] == "delay"){
		DELAYJD = splitData[1];
	}
}


/* ******************************************************
	Die Funktion fllt eine Zeichenketten mit Zahl vorne
	mit n-Zeichen auf.
	Z.B. 1 -> 01
	izahl = 		Die Zahl ohne fhrende Nullen
	ianzStellen = 	Die gewnschte Anzahl von Stellen
	sFuelzeichen =	Das gewnschet fhrende Zeichen
	
	Rckgabewert =	Z.B. "01" oder "0001"
   *************************************************** */
function LPAD( iZahl, iAnzStellen, sFuellzeichen )
{
    var sZahl = iZahl + "";
    while( sZahl.length < iAnzStellen )
        sZahl = sFuellzeichen + sZahl;
    return sZahl;
}



// Gibt einen Integer Wert zurck. Bei negativen Werten wird aufgerundet -3.2 = -3.
// Bei positiver abgerundet 3.2 = 3
function Int(x)
{
	if (x < 0) { 
		return(Math.ceil(x));	// Nchsthhere Ganzzahl (Aufrundung)
	} else 
		return(Math.floor(x));	// Nchstniedrigere Ganzzahl (Abrunden)
}



// Ermittelt das Modified Julianische Datum
// aus dem Julianischen Datums ab 1900.
//
function calculateMJD(JD)
{
	// Korrekturfaktor, da bei der Rckrechnung 1 ms im Ergebnis
	// unterschied ist. Dazu JD + 1 / Millisekunden pro Tag
	JD += 0.0000000115740740740;

	return (JD - 2400000.5);
}


// Ermittelt das Modified Julianische Datum
// aus dem Julianischen Datums.
//
function calculateDateFromMJD(MJD)
{
	// Variablen definieren und initialisieren.
	//
	var day = 0; var month = 0; var year = 0;
	var hour = 0; var minute = 0; var second = 0; var msecond = 0;
	var K = 0;
	
	// Werte des Datums ermitteln.
	//
	year = Int ( (MJD - 15078.2) / 365.25 );
	month = Int ( ( MJD - 14956.1 - Int (year * 365.25) ) / 30.6001 );
	day = Math.trunc(MJD - 14956 - Int ( year * 365.25 ) - Int ( month * 30.6001 ));

	// Korrekturwerte zuweisen.
	//
	if ( (month == 14) || (month == 15) )
		K = 1;
	else 
		K = 0;
		
	year += (K + 1900);
	month = month - 1 - (K * 12);

	// Uhrzeit Berechnung aus den Nachkommastellen des Julianischen Datums
	var jdRest = Math.abs( ( ( MJD )  - Math.trunc(MJD) ) );
	hour = Math.abs(Math.trunc(24. * jdRest));
	jdRest = (24. * jdRest) - hour;
	minute = Math.trunc(60. * jdRest);
	jdRest = (60. * jdRest) - minute;
	second = Math.trunc(60. * jdRest);
	jdRest = (60. * jdRest) - second;
	msecond = Math.trunc(1000. * jdRest);
	// Rckgabe Array von Datum und Uhrzeit als einzelne Werte.
	// Index 0 - 6. Hier muss Timezone und DST hinzugefgt werden
	return [day, month, year, hour + 2, minute, second, msecond];
}


// Ermittelt das Julianische Datum: Nach der Ephemeriden Rechnung.
//
function calculateJD()
{
	// Ermittelt die Anfangszeit der Verarbeitung in Millisekunden fr das Julianische Datum
	startProgressTimeJD = Date.now();
	// Variablen der Hilfsgren
	var y = 0; var m = 0; var B = 0; ret = ""; var Date1; var TIMEZONE = 2; var MJD = 0.0;
	var dateMJD = null; var date = null;
	var sendString = "";							// Der String fr Daten die an das externe Textfeld gesendet wird.
	
	// Zu berechnendes Datumsobjekt
	date = new Date();						// Aktuelles Datum
	year = date.getFullYear();				// Das Jahr
	month = date.getMonth() + 1;		// der Monat + 1, da 0 = Januar
	day = date.getDate();					// der Tag des Monats
	// Universal Time = GMT als Gleitkommazahl, also UTC - Timezone - DST
	UT = Number(date.getHours()) + (date.getMinutes()/60.) + (date.getSeconds()/3600.) + (date.getMilliseconds()/1000./3600.) - TIMEZONE;

	// Date Objekte fr die Umstellung von Julianischen- auf
	// Grgorianischen Kalender
	var date1 = new Date("1582", "10", "4");
	var date2 = new Date("1582", "10", "15")
	// Hilfsgren berechnen
	if (month <= 2) {
		y = year - 1;
		m = month + 12; 
	}else{
		y = year;
		m = month;
	}
	/* **************************************************
	 * Beschrnkt man sich bei den Berechnungen nur auf den
	 * Zeitraum vom 01.03.1900 - 28.02.2100, dann kann man
	 * B = -15 setzen.
	 * **************************************************/
	// bergebenes Datum liegt im Julianischen Bereich
	if (date <= date1){
		B = -2;
	// bergebenes Datum liegt im Gregorianischen Bereich
	}else if (date >= date2){
		B = Math.floor(y/400) - Math.floor(y/100);
	}
	// Julianisches Datum berechnen
	ret = Number(Math.floor(365.25 * y) + Math.floor(30.6001 * (m + 1)) + B + 1720996.5 + day + (UT/24));
	// Aus JD das Datum rckrechnen.
	Date1 = calculateDate(ret);
	if ( Date1[3] + Math.abs(TIMEZONE) == 24) {
		Date1[3] -= 22;
		Date1[0] += 1;
	} else
		Date1[3] += Math.abs(TIMEZONE);
	// Modified Julian Date ermitteln.
	MJD = calculateMJD(ret);
	// Datum aus dem MJD berechnen
	dateMJD = calculateDateFromMJD(MJD);
	
	// Die berechneten Daten an die Ausgabe senden (Hauptthread)
	//
	// Das aktuelle Datum und Uhrzeit und zum Sendestring hinzufgen.
	postMessage("DateAndTime=" + date);
	sendString += "[" + LPAD(dataLineNumber, 9, "0")+ "]" + "\t"
	sendString += "UTC : " + (date.getDate()+ "." + (date.getMonth()+ 1)+ "." + date.getFullYear()+ " - "  +
						  date.getHours()+ ":"  +  date.getMinutes()+ ":" + date.getSeconds()+ "." + date.getMilliseconds())+ "\t";
						  
	// Die Millisekunden getrennt, da sie im date Objekt beim Senden verloren gehen.
	postMessage("DateAndTimeMilliseconds=" + LPAD(date.getMilliseconds(), 3, "0"));
	
	// Die normale Urhrzeit = UTC .
	postMessage("UTC=" + LPAD(day, 2, "0") + "." + LPAD(month, 2, "0") + "." + year + " - " + 
				LPAD(date.getHours(), 2, "0") + ":" + LPAD(date.getMinutes(), 2, "0") + ":" + 
				LPAD(date.getSeconds(), 2, "0") + "." + LPAD(date.getMilliseconds(), 3, "0"));
	
	// Die Universal Time = UT und zum Sendestring hinzufgen.
	postMessage("UT=" + LPAD(day, 2, "0") + "." + LPAD(month, 2, "0") + "." + year + " - " + 
				LPAD((date.getHours() - TIMEZONE), 2, "0") + ":" + LPAD(date.getMinutes(), 2, "0") + ":" + 
				LPAD(date.getSeconds(), 2, "0") + "." + LPAD(date.getMilliseconds(), 3, "0"));
	sendString +=  (	"UT : "  +  (LPAD((date.getHours() - TIMEZONE), 2, "0") + ":" + LPAD(date.getMinutes(), 2, "0") + ":" + 
							LPAD(date.getSeconds(), 2, "0") + "." + LPAD(date.getMilliseconds(), 3, "0"))) + "\t";
				
	// Das Julianische Datum und zum Sendestring hinzufgen.
	postMessage("JD=" + ret);
	sendString +=  	"JD : " +  ret  +  "\t\t\t";	
	
	// Das aus den JD zurckgerechnete Datum.
	postMessage("JDDate=" + LPAD(Date1[0], 2, "0") + "." + LPAD(Date1[1], 2, "0") + "." + 
				LPAD(Date1[2],2 , "0") + " - " + LPAD(Date1[3], 2, "0") + ":" + LPAD(Date1[4], 2, "0") + 
				":" + LPAD(Date1[5], 2, "0") + "." + LPAD(Date1[6], 3, "0"));
	sendString +=  	"JD Datum : " + ( LPAD(Date1[0], 2, "0") + "." + LPAD(Date1[1], 2, "0") + "." + 
				LPAD(Date1[2],2 , "0") + " - " + LPAD(Date1[3], 2, "0") + ":" + LPAD(Date1[4], 2, "0") + 
				":" + LPAD(Date1[5], 2, "0") + "." + LPAD(Date1[6], 3, "0"))  +  "\t\t";
	
	
	// Das modifizierte Julianische Datum und zum Sendestring hinzufgen.
	postMessage("MJD=" + MJD);
	sendString +=  	"MJD : "  +  MJD  + "\n\t\t\t";
	
	// Das modifizierte Julianische Datum und zum Sendestring hinzufgen.
	postMessage("MJDDate=" + LPAD(dateMJD[0], 2, "0") + "." + LPAD(dateMJD[1], 2, "0") + 
				"." + dateMJD[2] + " - " + LPAD(dateMJD[3], 2, "0") + ":" + LPAD(dateMJD[4], 2, "0") + 
				":" + LPAD(dateMJD[5], 2, "0") + "." + LPAD(dateMJD[6], 3, "0"));
	sendString +=  	"MJD Datum : " + ( LPAD(dateMJD[0], 2, "0") + "." + LPAD(dateMJD[1], 2, "0") + 
				"." + dateMJD[2] + " - " + LPAD(dateMJD[3], 2, "0") + ":" + LPAD(dateMJD[4], 2, "0") + 
				":" + LPAD(dateMJD[5], 2, "0") + "." + LPAD(dateMJD[6], 3, "0"))  +  "\t\t";
				
	// Ermittelt die Endzeit der Verarbeitung in Millisekunden fr das Julianische Datum
	stopProgressTimeJD = Date.now();
	
	// Wenn die neue Verarbeitungszeit grer ist als die letzte ... 
	if ( parseInt(stopProgressTimeJD - startProgressTimeJD) > diffProgressTimeJD){
		// dann speichere die neue Verarbeitungszeit als die Hhere ...
		diffProgressTimeJD = parseInt(stopProgressTimeJD - startProgressTimeJD);
		// und ist die neue Verarbeitungszeit grer als die Wartezeit ...
		if ( diffProgressTimeJD > DELAYJD)
			// dann passe die Wartezeit an + eine kleine Sicherheit
			DELAYJD = diffProgressTimeJD + 10;
	}
	// Den an das Ausgabefenster zu sendenden Datenstring an den Hauptthread senden.
	postMessage("sendedWholeDataAsString=" + sendString );
	// Zeilennummerierung + 1.
	dataLineNumber++;
	
	// Sende die Verarbeitungszeit zur Ausgabe an den Hauptthread
	postMessage("Progress=" + diffProgressTimeJD);

	setTimeout("calculateJD()", DELAYJD);
}


/* **********************************************************************************
	Berechnung des Julianischen Datums JD und daraus die Rckrechnung des Datums
	und Uhrzeit.
   ******************************************************************************* */

// Ermittelt das Datum aus dem Julianische Datum.
// Nach der Ephemeriden Rechnung von Oliver Montenbruck
// bergeben wird das Julianische Datum und Rckgabe ist
// Tag, Monat, Jahr.
//
function calculateDate(JD)
{
	var day = 0; var month = 0; var year = 0;
	var hour = 0; var minute = 0; var second = 0; var msecond = 0;
	var a = 0; var b = 0; var c = 0; var d = 0; var e = 0; var f = 0;
	var x = 2299161;
	// Korrekturfaktor, da bei der Rckrechnung 1 ms im Ergebnis
	// unterschied ist. Dazu JD + 1 / Millisekunden pro Tag
	JD += 0.0000000115740740740;

	//Datumsberechnung aus dem Ganzzahlenanteil des julianischen Datums.
	//
	a = Math.floor(JD + 0.5);
	if ( a < x) { 
		c = a + 1524;
	}else if ( a >= x){
		b = Math.floor( (a - 1867216.25) / 36524.25 );
		c = a + b - Math.floor( b / 4 ) + 1525;
	}
	// Berechnung der Hilfsgren.
	//
	d = Math.floor( ( c - 122.1 ) / 365.25 );
	e = Math.floor ( d * 365.25 );
	f = Math.floor ( ( c - e ) / 30.6001 );
	
	// Berechnung des Datums.
	//
	day = Math.trunc(c - e - Math.floor( f * 30.6001 ) + ( JD + 0.5 - a ));
	month = f - 1 - 12 * Math.floor ( f / 14);
	year = d - 4715 - Math.floor ( ( 7 + month ) / 10 );
	
	// Uhrzeit Berechnung aus den Nachkommastellen des Julianischen Datums
	var jdRest = Math.abs( ( ( JD + 0.5 )  - Math.trunc(JD + 0.5) ) );
	hour = Math.abs(Math.trunc(24. * jdRest));
	jdRest = (24. * jdRest) - hour;
	minute = Math.trunc(60. * jdRest);
	jdRest = (60. * jdRest) - minute;
	second = Math.trunc(60. * jdRest);
	jdRest = (60. * jdRest) - second;
	msecond = Math.trunc(1000. * jdRest);
	// Rckgabe des Datums als Array. Index 0 - 6.
	// 
	return [day, month, year, hour, minute, second, msecond];
}


// Startet die beiden Funktionen als Thread im Background.
//
calculateJD();	// Berechnet alles zum Julianischen Datum und dem MJD.